package de.intevation.flys.client.client.ui.map;

import org.gwtopenmaps.openlayers.client.Map;
import org.gwtopenmaps.openlayers.client.MapOptions;
import org.gwtopenmaps.openlayers.client.MapWidget;
import org.gwtopenmaps.openlayers.client.layer.Vector;
import org.gwtopenmaps.openlayers.client.util.JObjectArray;
import org.gwtopenmaps.openlayers.client.util.JSObject;


public class FloodMap {

    public static final String LAYER_BARRIERS = "vector_layer_barriers";

    protected MapWidget mapWidget;
    protected Map       map;
    protected Vector    barrierLayer;


    public FloodMap() {
        MapOptions opts = new MapOptions();
        opts.setControls(new JObjectArray(new JSObject[] {}));
        opts.setNumZoomLevels(16);
        opts.setProjection(getRiverProjection());

        mapWidget = new MapWidget("510px", "635px", opts);
        map       = mapWidget.getMap();
    }


    public MapWidget getMapWidget() {
        return mapWidget;
    }


    public Map getMap() {
        return map;
    }


    public String getRiverProjection() {
        return "EPSG:4326";
    }


    public Vector getBarrierLayer() {
        if (barrierLayer == null) {
            barrierLayer = new Vector(LAYER_BARRIERS);
            map.addLayer(barrierLayer);
        }

        return barrierLayer;
    }


    public void setSize(String width, String height) {
        mapWidget.setWidth(width);
        mapWidget.setHeight(height);
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
